'code for the simulation of further scenarios to be run after baseline simulation 

' #####################################
' Model: description
' #####################################
 

'parameters

scalar t_inf=2.9    ' duration patient is infectious before being removed 
scalar t_inc=5.2   ' length of incubation 
scalar t_sd=17.8  ' duration from onset of symptoms to death, Verity et al. 
scalar t_shd=22.6 'duration from the onset of symptoms to hospital discharge, Verity et al.
scalar t_srec=  11.1         'duration from the onset of symptoms to recovery  for  mild patients 
scalar t_sh=5 ' duration from the onset of symptoms to hospitalization 
scalar p_fat= 0.0138     'mortality rate 
scalar p_sev=0.11     'probability of severe illness 
scalar p_mild=1-p_fat-p_sev 'probability of mild illness 
scalar p_ic= 0' probability with which an hospitalized for CV requires ICC

'R0  is generated as a variable as I want to set up scenarios for it 
smpl 1 95 'obs 95 is 8/03/2020
series rho=2.2
smpl 96 @last
series rho_3 = 2.2
'include programme to genario scenario for ICU beds 
include icc_cal.prg
'ICC capacity constraint
'include programme to genario scenario for ICU beds 
'include icc_cal.prg

'initial values for variables 
smpl 1 1 
genr POP=10000000		' Population in Lombardy
genr Infected=1  				' Infected 
genr Susceptible=9999999	     ' Susceptible
genr Esposed=0				' Esposed
genr Fatally=0 			' Infected Fatally Candidate
genr Mild =0			' Infected with Mild Symptoms
genr Severe=0				' Infected with Severe Symptoms
'Hospital or no hospital
genr Fatally_H=0			' Infected Fatalities Candidate in 
genr Severe_H=0           ' Infected with Severe Symptoms 
genr HOSPITALIZED=Fatally_H+Severe_H ' total  in hospital 
genr Mild=0			' Infected with Mild Symptoms
'Removal 
genr Severe_fat=0         ' death because of lack of IC capacity 
genr Removed_F=0      'removed with death 
genr Removed_H=0			    'removed in hospital 
genr Removed_M=0			'removed at home with mild symptoms
genr Recovered=Removed_H+Removed_M                     'recovered 
genr Effective_fat =Severe_fat+Removed_F ' total effective fatalities 

'model can be simulated with or without constant population 
'smpl 2 730
'POP=POP(-1) 

model SEIR 
SEIR.append Susceptible =Susceptible(-1)- (rho/t_inf)*(Infected(-1)/POP(-1))*Susceptible(-1)

SEIR.append Esposed=Esposed(-1) +(rho/t_inf)*(Infected(-1)/POP(-1))*Susceptible(-1) - (1/t_inc)*Esposed(-1)

SEIR.append Infected = Infected(-1) + (1/t_inc)*Esposed(-1)-(1/t_inf)*Infected(-1)

'dynamics of fatally ill
SEIR.append Fatally= Fatally(-1)+p_fat*(1/t_inf)*Infected(-1)-(1/t_sh)*Fatally(-1)

SEIR.append Fatally_H= Fatally_H(-1)+(1/t_sh)*Fatally(-1)-(1/(t_sd-t_sh-t_inf))*Fatally_H(-1)

SEIR.append Removed_F=Removed_F(-1)+(1/(t_sd-t_sh-t_inf))*Fatally_H(-1)
'dynamics of severely ill requiring hospitalization and not surviving if ICC care is not available

SEIR.append Severe= Severe(-1)+p_sev*(1/t_inf)*Infected(-1)-(1/t_sh)*Severe(-1)

SEIR.append Severe_H= Severe_H(-1)+(1/t_sh)*Severe(-1)-(1/(t_shd-t_sh-t_inf))*Severe_H(-1)-d(Severe_fat)

SEIR.append Severe_fat= Severe_fat(-1)+((p_ic*Severe_H(-1))>(icc-p_ic*Fatally_H(-1)))*(p_ic*Severe_H(-1)-(icc-p_ic*Fatally_H(-1)))*severe_h(-1)/(hospitalized(-1)+0.0001)


SEIR.append Removed_H=Removed_H(-1)+(1/(t_shd-t_sh-t_inf))*Severe_H(-1)  '-(Severe_fat- Severe_fat(-1))
'dynamics of mildly ill not requiring hospitalization
SEIR.append Mild= Mild(-1)+p_mild*(1/t_inf)*Infected(-1)-(1/t_srec)*Mild(-1)
SEIR.append Removed_M=Removed_M(-1)+(1/t_srec)*Mild(-1)
SEIR.append Recovered=Removed_H+Removed_M
'Compute the number of hospitalized by cumulating fatal and sev_H
SEIR.append HOSPITALIZED=Fatally_H+Severe_H
SEIR.append Effective_fat =Severe_fat+Removed_F
'Compute the dynamics of population by removing effective fatalities 
SEIR.append @identity POP=POP(-1)-(Effective_fat -Effective_fat (-1))

' #####################################
' baseline Scenario
' #####################################
smpl 1 700 
SEIR.solveopt(s=d, d=d)
SEIR.append assign @all  _2
SEIR.solve 


' #####################################
' Alternative Scenarios
' #####################################
 smpl 1 95
series rho_3=2.2
smpl 96 @last
series rho_3 = 0.95
smpl 1 @last

SEIR.scenario(n, a="_3") "lockdown, IC unconstrained"
SEIR.override rho
SEIR.solveopt(s=d, d=d)
SEIR.solve

