' program to transfer data from the simulation to the daily database and graphing
' to be run after SEIRH.prg 
'written by Carlo A.Favero 29th March 2020
'carlo.favero@unibocconi.it
pageselect SIM
!n=730
!v=20
matrix(!n,!v) matrixdata
%LIST ="_0 _1 _2 _3 " 
for %i  {%LIST}
smpl 1 1 
esposed{%i}=0
hospitalized{%i}=0
effective_fat{%i}=0
removed_h{%i}=0
recovered{%i}=0 
next
smpl 1 730
vector(!n) a
!num=1
%LIST ="esposed_0 hospitalized_0 effective_fat_0 removed_h_0 recovered_0 esposed_1 hospitalized_1 effective_fat_1 removed_h_1 recovered_1 esposed_2 hospitalized_2 effective_fat_2 removed_h_2 recovered_2 esposed_3 hospitalized_3 effective_fat_3 removed_h_3 recovered_3" 
for %i  {%LIST}
stom({%i},a)
matplace(matrixdata,(a),1,!num)
!num=!num+1
next

copy  sim\matrixdata Lombardy\matrixdata
pageselect lombardy
%LIST ="_0 _1 _2 _3 " 
for %i  {%LIST}
series esposed{%i}=0
series hospitalized{%i}=0
series effective_fat{%i}=0
series removed_h{%i}=0
series recovered{%i}=0 
next
group  group_sim esposed_0 hospitalized_0 effective_fat_0 removed_h_0 recovered_0 esposed_1 hospitalized_1 effective_fat_1 removed_h_1 recovered_1 esposed_2 hospitalized_2 effective_fat_2 removed_h_2 recovered_2 esposed_3 hospitalized_3 effective_fat_3 removed_h_3 recovered_3
sample s1 8/03/2020-95 8/03/2020-95+730-1
mtos(matrixdata,group_sim,s1)
delete s1

' #####################################
' Graphs 
' #####################################
smpl @first @first+730
genr lethality_SIER= effective_fat_2/(recovered_2+esposed_2+effective_fat_2)

' #####################################
' Figure 0: Data Description 
' #####################################
smpl 24/02/2020 10/04/2020
delete fig_0_1*
%TYPE="fig_0_1"
delete {%TYPE}*
graph  {%TYPE}.line lethality  lethality_SIER 
	 {%TYPE}.axis grid zeroline
	 {%TYPE}.option linepat	' need to set linepat
	{%TYPE}.draw(line,left,rgb(180,180,180)) 0
	 {%TYPE}.elem(1) lcolor(red)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 {%TYPE}.elem(2) lcolor(black)  lwidth(1.25) symbol(star) symbolsize(l)
      {%TYPE}.elem(3) lcolor(green)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
 	 {%TYPE}.name(1) Ratio of fatalities to total identified COVID cases in Lombardy
	 {%TYPE}.name(3) Ratio of fatalities to total identified COVID cases in Veneto
       {%TYPE}.name(2) Ratio of fatalities to total COVID cases predicted by a SIER with CFR=0.0138
     {%TYPE}.draw(line, bottom, color(blue), width(2), pattern(1)) 8/3/2020
	 'fig_1.addtext(t) "Figure 1: Actual and Simulated Fatalities"



delete fig_0_2*
%TYPE="fig_0_2"
delete {%TYPE}*
graph  {%TYPE}.line ratio_icu ratio_icu_veneto
	 {%TYPE}.axis grid zeroline
	 {%TYPE}.option linepat	' need to set linepat
	{%TYPE}.draw(line,left,rgb(180,180,180)) 0
	 {%TYPE}.elem(1) lcolor(red)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 {%TYPE}.elem(2) lcolor(green)  lwidth(1.25) symbol(star) symbolsize(l)
 	 {%TYPE}.elem(3) lcolor(blue)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 '{%TYPE}.elem(4) lcolor(blue)  lwidth(1.25) symbol(star) symbolsize(l)
      '{%TYPE}.elem(5) lcolor(yellow)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 {%TYPE}.name(1) Share of hospitalized patients in ICU, Lombardy
	 {%TYPE}.name(2) Share of hospitalized patients in ICU, Veneto 
	 '{%TYPE}.name(3) 
 {%TYPE}.draw(line, bottom, color(blue), width(2), pattern(1)) 8/3/2020
	

delete fig_0_3*
%TYPE="fig_0_3"
delete {%TYPE}*
graph  {%TYPE}.line d(deceduti)  d(deceduti_veneto) 
	 {%TYPE}.axis grid zeroline
	 {%TYPE}.option linepat	' need to set linepat
	{%TYPE}.draw(line,left,rgb(180,180,180)) 0
	 {%TYPE}.elem(1) lcolor(black)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 {%TYPE}.elem(2) lcolor(black)  lwidth(1.25) symbol(star) symbolsize(l)
 	 {%TYPE}.elem(3) lcolor(red)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 '{%TYPE}.elem(4) lcolor(red)  lwidth(1.25) symbol(star) symbolsize(l)
      {%TYPE}.elem(4) lcolor(green)  lwidth(1.25) symbol(star) symbolsize(l)
	 {%TYPE}.name(1) daily fatalities  Lombardy 
	 {%TYPE}.name(2) dailiy fatalities Veneto 
	 {%TYPE}.name(3) total number of patients in ICU Lombardy
     {%TYPE}.name(4) total number of patients in ICU Veneto

 {%TYPE}.draw(line, bottom, color(blue), width(2), pattern(1)) 8/3/2020


' #####################################
' Figure 1: The importance of the ICC constraint 
' #####################################
smpl 08/03/2020 30/6/2020
delete fig_1*
%TYPE="fig_1"
delete {%TYPE}*
graph  {%TYPE}.line d(deceduti) d(effective_fat_1) d(effective_fat_3) d(deceduti_veneto) 
	 {%TYPE}.axis grid zeroline
	 {%TYPE}.option linepat	' need to set linepat
	{%TYPE}.draw(line,left,rgb(180,180,180)) 0
	 {%TYPE}.elem(1) lcolor(black)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 {%TYPE}.elem(2) lcolor(red)  lwidth(1.25) symbol(star) symbolsize(l)
 	 {%TYPE}.elem(3) lcolor(blue)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 {%TYPE}.elem(4) lcolor(black)  lwidth(1.25) symbol(star) symbolsize(l)
      {%TYPE}.elem(5) lcolor(green)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 {%TYPE}.name(1) Observedy daily fatalities in Lombardy  
	 {%TYPE}.name(2) Simulated daily fatalities with IC observed capacity,  lockdown , Pic=0.2
	 {%TYPE}.name(3) Simulated daily fatalities  with no IC capacity constraint and lockdown
{%TYPE}.name(4) Observedy daily fatalities in Veneto
' {%TYPE}.draw(line, bottom, color(blue), width(2), pattern(3)) 8/3/2020
	 fig_1.addtext(t) "Figure 1: Actual and Simulated Fatalities"
show fig_1
' #####################################
' Figure 2: The importance of the ICC constraint and the lockdown 
' #####################################

delete fig_2*
%TYPE="fig_2"
delete {%TYPE}*
graph  {%TYPE}.line (deceduti) (effective_fat_1) (effective_fat_3) '(effective_fat_2)
{%TYPE}.axis grid zeroline
{%TYPE}.option linepat	' need to set linepat
{%TYPE}.draw(line,left,rgb(180,180,180)) 0
{%TYPE}.elem(1) lcolor(black)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
{%TYPE}.elem(2) lcolor(red)  lwidth(1.25) symbol(star) symbolsize(l)
{%TYPE}.elem(3) lcolor(blue)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
{%TYPE}.elem(4) lcolor(green)  lwidth(1.25) symbol(star) symbolsize(l)
'{%TYPE}.elem(5) lcolor(yellow)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
{%TYPE}.name(1) Observedy total fatalities in Lombardy  
{%TYPE}.name(2) simulated total fatalities with IC observed capacity and lockdown
{%TYPE}.name(3) simulated total fatalities  with no IC capacity constraint and lockdown
'{%TYPE}.name(4) simulated total fatalities  with IC capacity 1300 and no lockdown
' {%TYPE}.draw(line, bottom, color(blue), width(2), pattern(3)) 8/3/2020
fig_2.addtext(t) "Figure 2: The importance of the lockdown and IC capacity"
show fig_2

smpl 24/02/2020 30/6/2020
' #####################################
' Figure 3: Hospitalization 
' #####################################
delete fig_3*
%TYPE="fig_3"
delete {%TYPE}*
graph  {%TYPE}.line (ricoverati) (hospitalized_1) (hospitalized_3) 
{%TYPE}.axis grid zeroline
{%TYPE}.option linepat	' need to set linepat
{%TYPE}.draw(line,left,rgb(180,180,180)) 0
{%TYPE}.elem(1) lcolor(black)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
{%TYPE}.elem(2) lcolor(red)  lwidth(1.25) symbol(star) symbolsize(l)
{%TYPE}.elem(3) lcolor(blue)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
{%TYPE}.elem(4) lcolor(green)  lwidth(1.25) symbol(star) symbolsize(l)
'{%TYPE}.elem(5) lcolor(yellow)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
{%TYPE}.name(1) Observed total hospitalized in Lombardy  
{%TYPE}.name(2) simulated total hospitalized with IC observed capacity  and lockdown
{%TYPE}.name(3) simulated total hospitalized  with no IC capacity constraint and lockdown
{%TYPE}.name(4) simulated total fatalities  with IC capacity 1300 and no lockdown
 {%TYPE}.draw(line, bottom, color(blue), width(2), pattern(3)) 8/3/2020
fig_3.addtext(t) "Figure 3: Actual and Simulated Hospitalization"
show fig_3


' #####################################
' Figure 4: Recovered 
' #####################################
smpl 8/3/2020 30/05/2020
delete fig_4*
%TYPE="fig_4"
delete {%TYPE}*
graph  {%TYPE}.line (dimessi_guariti) (recovered_1) (removed_h_1) 
{%TYPE}.axis grid zeroline
{%TYPE}.option linepat	' need to set linepat
{%TYPE}.draw(line,left,rgb(180,180,180)) 0
{%TYPE}.elem(1) lcolor(black)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
{%TYPE}.elem(2) lcolor(red)  lwidth(1.25) symbol(star) symbolsize(l)
{%TYPE}.elem(3) lcolor(blue)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
{%TYPE}.elem(4) lcolor(green)  lwidth(1.25) symbol(star) symbolsize(l)
'{%TYPE}.elem(5) lcolor(yellow)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
{%TYPE}.name(1) Observed total recovered in Lombardy  
{%TYPE}.name(2) Simulated total recovered with observed IC capacity and lockdown
{%TYPE}.name(3) Simulated total recovered from hospital with observed IC capacity and lockdown
'{%TYPE}.name(4) simulated total fatalities  with IC capacity 1300 and no lockdown
 '{%TYPE}.draw(line, bottom, color(blue), width(2), pattern(3)) 8/3/2020
fig_4.addtext(t) "Figure 4: Actual and Simulated Recoveries"
show fig_4

smpl 9/2/2020 30/4/2020
' #####################################
' Figure 6: d(casi_attivi) espoused
' #####################################
delete fig_6*
%TYPE="fig_6"
delete {%TYPE}*
graph  {%TYPE}.line d(casi_attivi) d(esposed_1)  
	 {%TYPE}.axis grid zeroline
	 {%TYPE}.option linepat	' need to set linepat
	{%TYPE}.draw(line,left,rgb(180,180,180)) 0
	 {%TYPE}.elem(1) lcolor(black)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 {%TYPE}.elem(2) lcolor(red)  lwidth(1.25) symbol(star) symbolsize(l)
 	 {%TYPE}.elem(3) lcolor(blue)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 '{%TYPE}.elem(4) lcolor(blue)  lwidth(1.25) symbol(star) symbolsize(l)
      '{%TYPE}.elem(5) lcolor(yellow)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 {%TYPE}.name(1) Observedy daily change in esposed (casi attivi)   
	 {%TYPE}.name(2) Simulated daily change in esposed with observed IC capacity 
	 '{%TYPE}.name(3) simulated daily fatalities  with IC capacity 1300 and lockdown
 {%TYPE}.draw(line, bottom, color(blue), width(2), pattern(3)) 8/3/2020
	 'fig_6.addtext(t) "Figura 5: ratio of ICU patients to total hospitalized patients"
show fig_6


' #####################################
' Figure 7: (casi_attivi) espoused
' #####################################
delete fig_7*
%TYPE="fig_7"
delete {%TYPE}*
graph  {%TYPE}.line (casi_attivi) (esposed_1)  
	 {%TYPE}.axis grid zeroline
	 {%TYPE}.option linepat	' need to set linepat
	{%TYPE}.draw(line,left,rgb(180,180,180)) 0
	 {%TYPE}.elem(1) lcolor(black)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 {%TYPE}.elem(2) lcolor(red)  lwidth(1.25) symbol(star) symbolsize(l)
 	 {%TYPE}.elem(3) lcolor(blue)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 '{%TYPE}.elem(4) lcolor(blue)  lwidth(1.25) symbol(star) symbolsize(l)
      '{%TYPE}.elem(5) lcolor(yellow)  lwidth(1.25) symbol(filledcircle) symbolsize(l)
	 {%TYPE}.name(1) Observedy daily  esposed (casi attivi)   
	 {%TYPE}.name(2) Simulated daily  esposed with observed IC capacity
	 '{%TYPE}.name(3) simulated daily fatalities  with IC capacity 1300 and lockdown
     {%TYPE}.draw(line, bottom, color(blue), width(2), pattern(3)) 8/3/2020
	 'fig_6.addtext(t) "Figura 5: ratio of ICU patients to total hospitalized patients"
show fig_7


